package healthhelper.action.impl;

import healthhelper.action.Action;
import healthhelper.dto.Dto;
import healthhelper.entity.Menu;
import healthhelper.logic.Logic;

import java.util.Iterator;
import java.util.List;

import org.seasar.framework.container.S2Container;
import org.seasar.framework.container.factory.S2ContainerFactory;

public class ActionImpl implements Action {

	private Logic logic;

	public static void main(String[] args) {
		final String PATH = "healthhelper/dicon/HealthHelper.dicon";
		S2Container container = S2ContainerFactory.create(PATH);
		Dto dto = createDto(args);
		Action action = (Action) container.getComponent(Action.class);
		action.doAction(dto);
	}

	private static Dto createDto(String[] args) {
		Dto dto = new Dto();
		dto.setBudget(Integer.parseInt(args[0]));
		dto.setCarefulCalorie(false);
		dto.setMoreVolume(false);
		if (args[1].equals("y")) {
			dto.setCarefulCalorie(true);
		}
		if (args[2].equals("y")) {
			dto.setMoreVolume(true);
		}
		return dto;
	}

	public void doAction(Dto dto) {
		printMenu(dto);
	}

	private void printMenu(Dto dto) {
		List menuList = logic.getMenuList(dto);
		for (Iterator iterator = menuList.iterator(); iterator.hasNext();){
			Menu menu = (Menu) iterator.next();
			System.out.println(menu.getName()
					+ " " + menu.getCalorie() 
					+ " " + menu.getPrice());
		}
	}

	public Logic getLogic() {
		return logic;
	}

	public void setLogic(Logic logic) {
		this.logic = logic;
	}
}
